#ifndef _TRANS_WP_H

#define _TRANS_WP_H

enum { //-------------Common text attributes, use in WP_Attr::attr_type-----------
	font = 'FONT',
	color = 'COLR',
	size = 'SIZE',
	style = 'STYL',
	justification = 'JUST',
	spacing = 'SPCE',
	tab_width = 'TABS'
};

typedef struct {
	uint32 attr_type;
	const void *data;
	size_t size;
} WP_Attr;

class attr_list;

class TranslatorWP : public BArchivable {
	public:
		TranslatorWP(void);
		TranslatorWP(const char *plainText);
		TranslatorWP(BMessage *archive);
		//
		void SetText(const char *plainText);
		const char *Text(void);
		//
		void pushAttr(int32 begin, int32 end, uint32 type, const void *data, size_t size);
		WP_Attr *getAttr(int32 begin, int32 *end, int32 index = 0); //-----do NOT deallocate----
		WP_Attr *getAttr(int32 *begin, int32 end, int32 index = 0); //-----do NOT deallocate----
		//-----------Archival-------------------------------------------------------
		status_t Archive(BMessage *archive,bool deep = true);
		static BArchivable *Instantiate(BMessage *archive);
		//
		~TranslatorWP(void);
	private:
		BString text;
		attr_list *begin_attrs, *end_attrs;
};

#endif